package iciPlugin;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Random;

import prompt.csv.data.CSVLog;
import prompt.csv.data.SortedEvent;
import prompt.csv.utils.UnicodeBOMInputStream;

public class gr {

	public static void main(String[] args) throws Exception {
		// TODO Auto-generated method stub
		
		CSVLog csv = compress(read("logs/AmaSmartLog_robotProcess.csv"), 7250, 0, 2) ;
		for(int i=0;i<csv.getHeaders().size();i++) {
			System.out.println(csv.getHeaders().get(i)+" : "+GroupingRate.GetGroupingScore(csv, i));
		}
		
		
	}
public static CSVLog sortCSV(CSVLog csv, int timeIndex) throws Exception {
		
		
		ArrayList<SortedEvent> eventsList = new ArrayList<SortedEvent>();
		
	for(int i=0 ; i<csv.getEntries(); i++) {
			
			List<String> event = csv.getLine(i);
			String timestamp = event.get(timeIndex);
			
			SortedEvent se = new SortedEvent(event,timestamp);
			eventsList.add(se);
	}
		
	   Collections.sort(eventsList);
	   
	   CSVLog sortedlog = new CSVLog("slog");
	   
	   List<String> headerL = csv.getHeaders();
		StringBuilder header = new StringBuilder();
		for(int ch = 0 ; ch<headerL.size(); ch++) {
			 header.append(headerL.get(ch));
			 if(ch<headerL.size()-1) {
				 header.append(",");
			 }
		}
	
	   sortedlog.addLine(header.toString());
	   
	   
	   for(SortedEvent ee : eventsList) {
		   List<String> entry  =ee.getEvent();
			StringBuilder event = new StringBuilder();
		   for(int ce = 0 ; ce<entry.size(); ce++) {
			   event.append(entry.get(ce));
			   if(ce<entry.size()-1) {
					 event.append(",");
				 }
			   
		   }
		   sortedlog.addLine(event.toString());
	   }
	   
	   sortedlog.prepare();

		return sortedlog ;
		
	}
	private static CSVLog compress(CSVLog csv, int samplingSize, int samplingMethod, int timeIndex) throws Exception {
		
		 csv = sortCSV(csv,timeIndex);
		
		CSVLog selectedevents = new CSVLog("compressed log");
		
		
		int start = 0 ;
		int limit = 0  ;
		
		// check if sample size is lower than file size, otherwise the limit is the file size
		if(samplingSize<csv.getEntries()) {
			
			// check sampling method
			if(samplingMethod==0) {
				// top entries
				limit =  samplingSize ;
			}
			else if(samplingMethod==1) {
				// generate random start in the range  [0, filezie-samplingsize]
				Random rand = new Random();
				int min = 0 ;
				int max = csv.getEntries()-samplingSize ;
				start = rand.nextInt((max - min) + 1) + min;
				
				/// limit = start + sampling size
				limit = start + samplingSize;
				
			
			}
			
		}
		else {
			limit =  samplingSize ;
		}
		
		System.out.println("sampling range["+start+","+limit+"]");
		
		// copy header
		StringBuilder header = new StringBuilder();
		for(String col : csv.getHeaders()) {
			header.append(col);
			header.append(',');
		}
		selectedevents.addLine(header.toString());
		
		// copy n entries
		for(int i=start; i<limit ; i++) {
			
			StringBuilder line = new StringBuilder();
			for(String col : csv.getLine(i)) {
				line.append(col);
				line.append(',');
			}
			
			selectedevents.addLine(line.toString());
			
		}
		
		selectedevents.prepare();
		return selectedevents ;
	}
	
	public static CSVLog read(String file) throws Exception {
		CSVLog log = new CSVLog(file);
		UnicodeBOMInputStream ubis = new UnicodeBOMInputStream(new FileInputStream(file));
		ubis.skipBOM();
		InputStreamReader isr = new InputStreamReader(ubis);
		BufferedReader reader = new BufferedReader(isr);
		String readLine;
		while ((readLine = reader.readLine()) != null) {
			log.addLine(readLine);
		}
		reader.close();
		isr.close();
		ubis.close();
		log.prepare();
		return log;
	}

}
